<template>
    <div class="departmentChoose">
      <treeselect v-model="departmentId"
                  :multiple="multiple"
                  :options="menuOptions"
                  :normalizer="normalizer"
                  :show-count="true"
                  :placeholder=placeholder
                  @input="handleTreeSelect"
                  :flat="flat"

      />
    </div>
</template>

<script>
    import {fetchTree} from '@/api/admin/dept'
    import { initDepartment } from "@/api/admin/dept";
    import Treeselect from "@riophae/vue-treeselect"
    import "@riophae/vue-treeselect/dist/vue-treeselect.css"
    export default {
        name: "departmentTreeChoose",
        components:{Treeselect},
        props:{
            multiple:{  //是否是多选
                type:Boolean,
                default:false,
            },
            flat: {
              type:Boolean,
              default:false,
            },
            placeholder: {
                type: String,
                default: "点击选择部门",
            }
        },
        data() {
            return {
                menuOptions:[], //treeselect数据回显
                departmentId: null,
                dataDep: [],
            }
        },
        mounted() {
            this.getTreeselect()
            // this.initDepartmentData()
        },
        methods: {
            // initDepartmentData() {
            //     initDepartment().then((res) => {
            //         if (res.data.code==0) {
            //             res.data.data.forEach(function (e) {
            //                 if (e.isParent) {
            //                     e.loading = false;
            //                     e.children = [];
            //                 }
            //                 if (e.status == -1) {
            //                     e.title = "[已禁用] " + e.title;
            //                     e.disabled = true;
            //                 }
            //                 e.isParent = true;
            //                 // e.loading = true;
            //                 e.title = e.name;
            //                 e.id = e.deptId;
            //             });
            //             this.dataDep = res.data.data;
            //             console.log(this.dataDep)
            //         }
            //     });
            // },
            handleTreeSelect(node) { //选择一个选项后发出。
                this.$emit('on-change',this.departmentId)
            },
            getTreeselect() {
                fetchTree().then(res => {
                    this.menuOptions = res.data.data
                })
            },
            initData(val) { //重置
                this.searchKey = val
            },
            setData(ids, title) {
                if (this.multiple) {
                    this.departmentId = ids;
                } else {
                    this.departmentId = [];
                    this.departmentId.push(ids);
                }
                this.departmentId = ids
                this.$emit("on-change", this.departmentId);
            },
            /** 转换菜单数据结构 */
            normalizer(node) {
                if (node.children && !node.children.length) {
                    delete node.children;
                }
                return {
                    id: node.id,
                    label: node.name,
                    children: node.children
                };
            },
        }
    }
</script>

<style scoped>
</style>
